package jgraspvex

class BinaryTreeNodeK<T : Comparable<T>> {

    public var value: T

    public var left: BinaryTreeNodeK<T>

    public var right: BinaryTreeNodeK<T>

    constructor(v : T) {
        value = v
        left = this
        right = this
    }

    constructor(v : T, l : BinaryTreeNodeK<T>, r : BinaryTreeNodeK<T>) {
        value = v
        left = l
        right = r
    }
}